<?php
require('fpdf.php');

class PDF_MySQL_Table extends FPDF
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;

function Header()
{
	//Print the table header if necessary
	if($this->ProcessingTable)
		$this->TableHeader();
}

function TableHeader()
{
	$this->SetFont('Arial','B',8);
	//$this->SetX($this->TableX);
	$fill=!empty($this->HeaderColor);
	if($fill)
		$this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
	foreach($this->aCols as $col)


		$this->Cell($col['w'],10,$col['c'],0,0,$col['a'],$fill);
	$this->Ln();
}


function Rownew($data)
{

    //Calculate the height of the row
    $nb=0;
   
    $nb=max($nb,$this->NbLines($w,$data[$i]));

		
    $h=6;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	
	if($i==0){
	$w = 5;
	$a ="L";
	}
	if($i==1){
	$w = 20;
	$a ="L";
	}
	if($i==2){
	$w = 10;
	$a ="L";
	}
	if($i==3){
	$w = 25;
	$a ="L";
	}
	if($i==4){
	$w = 50;
	$a ="L";
	}
	if($i==5){
	$w = 50;
	$a ="L";
	}
	if($i==6){
	$w = 10;
	$a ="L";
	}
	if($i==7){
	$w = 40;
	$a ="L";
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',8);
		if($i==6){
        $this->MultiCell($w,5,$data[$i],0,$a);
		}else{
		  $this->MultiCell($w,5,$data[$i],0,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}



function Row($data)
{

    //Calculate the height of the row
    $nb=0;
   
    $nb=max($nb,$this->NbLines($w,$data[$i]));

		
    $h=6;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 7;
	$a ="L";
	}
	if($i==1){
	$w = 20;
		$a ="L";
	}
	if($i==2){
	$w = 20;
		$a ="L";
	}


	if($i==3){
	$w = 60;
	$a ="L";
	}


		if($i==4){
	$w = 15;
	$a ="L";
	}
		if($i==5){
	$w = 15;
	$a ="L";
	}
		if($i==6){
	$w = 20;
		$a ="R";
	}
	
		if($i==7){
	$w = 20;
		$a ="R";
	}
	
	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',8);
		if($i==6){
        $this->MultiCell($w,5,$data[$i],0,$a);
		}else{
		  $this->MultiCell($w,5,$data[$i],0,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtestnew($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 90;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 155;
	$a ="L";
	}
	if($i==1){
	$w = 67;
	$a ="R";
	}
	if($i==2){
	$w = 25;
	$a ="R";
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		if($i==2){
        $this->Rect($x,$y,$w,$h);
		}
        //Print the text
			if($i==0){
		$this->SetFont('Arial','',8);
		}else{
				$this->SetFont('Arial','B',10);
		}
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}


function Rowboldtest($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 100;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 100;
	$a ="R";
	}
	if($i==1){
	$w = 20;
	$a ="R";
	}
	if($i==2){
	$w = 20;
	$a ="R";
	}
		if($i==3){
	$w = 20;
	$a ="R";
	}
			if($i==4){
	$w = 20;
	$a ="R";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		//if($i==1){
      //  $this->Rect($x,$y,$w,$h);
		//}
        //Print the text
		$this->SetFont('Arial','',9);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowall($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 20;
		$a ="C";
	}
	if($i==2){
	$w = 37;
	}

	if($i==3){
	$w = 60;
	}
	if($i==4){
	$w = 20;
	$a ="C";
	}
	if($i==5){
	$w = 25;
	$a ="R";
	}
	if($i==6){
	$w = 25;
		$a ="R";
	}
	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        $this->MultiCell($w,$h,$data[$i],R,$a);
		}else{
		  $this->MultiCell($w,$h,$data[$i],LR,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function RowanAtkinson($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 10;
	}
	if($i==2){
	$w = 10;
	}

	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 120;
	}
	if($i==1){
	$w = 20;
		$a ="R";
	}
	if($i==2){
	$w = 40;
	$a ="R";
	}


	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		if($i==1 ){
        $this->Rect(120,198,75,10);
		}
        //Print the text
		if( $i==2){
	$this->SetFont('Arial','B',9);	
        $this->MultiCell($w,5,$data[$i],0,$a);
	}else{
		$this->SetFont('Arial','',9);
			
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
	}
    }
    //Go to the next line
    $this->Ln($h);
}
function CheckPageBreak($h)
{
    //If the height h would cause an overflow, add a new page immediately
    if($this->GetY()+$h>$this->PageBreakTrigger)
        $this->AddPage($this->CurOrientation);
}
function NbLines($w,$txt)
{
    //Computes the number of lines a MultiCell of width w will take
    $cw=&$this->CurrentFont['cw'];
    if($w==0)
        $w=$this->w-$this->rMargin-$this->x;
    $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
    $s=str_replace("\r",'',$txt);
    $nb=strlen($s);
    if($nb>0 and $s[$nb-1]=="\n")
        $nb--;
    $sep=-1;
    $i=0;
    $j=0;
    $l=0;
    $nl=1;
    while($i<$nb)
    {
        $c=$s[$i];
        if($c=="\n")
        {
            $i++;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
            continue;
        }
        if($c==' ')
            $sep=$i;
        $l+=$cw[$c];
        if($l>$wmax)
        {
            if($sep==-1)
            {
                if($i==$j)
                    $i++;
            }
            else
                $i=$sep+1;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
        }
        else
            $i++;
    }
    return $nl;
}

function CalcWidths($width,$align)
{
	//Compute the widths of the columns
	$TableWidth=0;
	foreach($this->aCols as $i=>$col)
	{
		$w=$col['w'];
		if($w==-1)
			$w=$width/count($this->aCols);
		elseif(substr($w,-1)=='%')
			$w=$w/100*$width;
		$this->aCols[$i]['w']=$w;
		$TableWidth+=$w;
	}
	//Compute the abscissa of the table
	if($align=='C')
		$this->TableX=max(($this->w-$TableWidth)/2,0);
	elseif($align=='R')
		$this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
	else
		$this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align)
{
	//Add a column to the table
	if($field==-1)
		$field=count($this->aCols);
	$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array(),$id)
{
	
	$sql1= "SELECT * FROM debtor_invoice where id='$id'";
$result = mysql_query($sql1);
$cv= mysql_fetch_array($result);
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	$dataprint2 = array();
	//$this->SetX($this->TableX);
	$r =1;
	while($row=mysql_fetch_array($res)){
		// $sql1="SELECT * FROM arinvoice_item WHERE grid='$res[grid]' group by code";
		// $quote= mysql_fetch_array(mysql_query($sql1));
		$sql1="SELECT sum(qty) as totalqty FROM arinvoice_item WHERE grid='$row[grid]' and code='$row[code]' and price='$row[price]' ";
		$quote= mysql_fetch_array(mysql_query($sql1));

		// $subamount = ($row['price']*$row['qty'])-$row['discount'];
		// $taxamount = ($subamount*$row['taxpercent'])/100;
		$taxamount = ($subamount*$row['taxpercent'])/100;
		$afterdiscount = $row['price']-$row['discount'];
		$subamount = ($row['price']-$row['discount'])*$quote[totalqty];
		
		$dataprint[0] = $r;
		$dataprint[1] = $cv[refdoc];
		$dataprint[2] = $row[taxcode];
		$dataprint[3] = $row[name];
		$dataprint[4] = "CONT";
		$dataprint[5] = $quote[totalqty];
		$dataprint[6] = number_format($afterdiscount,2,'.',',');
		$dataprint[7] = number_format($subamount,2,'.',',');
		
		$this->Row($dataprint);
		$a+=1;
		$toexl += number_format($subamount,2,'.','');
		$togst += number_format($taxamount,2,'.','');
		$r+=1;
	}
	
	$this->Ln(5);
	$x=$this->GetX();
	$y=$this->GetY();
	$num = number_format($toexl+$togst,2,'.','');
	$nw = new Numbers_Words();
	// $cduit ="RINGGIT MALAYSIA : ".strtoupper($nw->toCurrency($num));
	$cduit ="MYR : ".strtoupper($nw->toCurrency($num));
	$dataprint2[0] = 	$cduit;
	$this->Rowboldtestnew($dataprint2);
	$this->SetFont('Arial','B',10);
	$this->SetXY($x+120,$y);
	$this->MultiCell(23,5,"TOTAL PAYABLE",0,"L");
	$this->SetFont('Arial','BU',10);
	$this->SetXY($x+155,$y);
	$this->MultiCell(23,5,$num,0,"R");
	$this->SetFont('Arial','',8);
	
	$this->SetXY($x,$y+5);
	$this->MultiCell(100,5,"Remark : ".$cv[remark],0,'L');
	$this->SetFont('Arial','',8);

	

	
	$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}


function Table2($query,$prop=array(),$id)
{
	
	$sql1= "SELECT * FROM debtor_invoice where id='$id'";
	$result = mysql_query($sql1);
	$cv= mysql_fetch_array($result);
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	$dataprint2 = array();
	//$this->SetX($this->TableX);
	$r =1;
	while($row=mysql_fetch_array($res)){

		$subamount = ($row['price']*$row['qty'])-$row['discount'];
		$taxamount = ($subamount*$row['taxpercent'])/100;

		$dataprint[0] = $r;
		
		$sql1= "SELECT * FROM order_entry WHERE docno='".$cv[refdoc]."'";
		$cv2 = mysql_fetch_array(mysql_query($sql1));
		$sql1= "SELECT * FROM order_entry_container WHERE containerno='".$row[pono]."' and orderid='$cv2[id]'";
		$cvotr = mysql_fetch_array(mysql_query($sql1));
		$lotno = str_pad($cvotr[seqno],3,"0",STR_PAD_LEFT);
		
		$dataprint[1] = $cvotr[containerno];
		$dataprint[2] = $cvotr[size]."".$cvotr[typesize];
		$dataprint[3] = $cvotr[requireddate]." ".$cvotr[requiredtime];
		// $sql1= "SELECT * FROM debtor where code='$cv2[emptydehire]'";
		$sql1= "SELECT * FROM debtor WHERE code='$cvotr[emptydehire]'";
		$dbdebtor1 = mysql_fetch_array(mysql_query($sql1));
		// $dbdebtor1[name] = str_replace("(","\n(",$dbdebtor1[name]);
		$dataprint[4] = $dbdebtor1[name];
		$sql1= "SELECT * FROM debtor WHERE code='$cv2[deliverto]'";
		$dbdebtor2 = mysql_fetch_array(mysql_query($sql1));
		$dataprint[5] = $dbdebtor2[name];
		$sql1= "SELECT * FROM deliveryaddress WHERE debcode='$dbdebtor2[code]'";
		$dbdebtoraddress = mysql_fetch_array(mysql_query($sql1));
		$dataprint[6] = $dbdebtoraddress[areacode];
		$dataprint[7] = $cv2[docno]."-".$lotno;
				
		
		$this->Rownew($dataprint);
	
	}
	
	
	

	
$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}
}
?>
